Index: /trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 2835)
@@ -1357,23 +1180,77 @@
                          *subslope_dist(ig,islope) 
         ENDDO
-       ENDDO
       ENDDO
-
+    ENDDO
 
     DO ig = 1,ngrid
-
-        emis(ig) =0. 
-        DO islope = 1,nslope
-          emis(ig)= emis(ig)+emiss_slope(ig,islope) &
+      emis(ig) =0. 
+      DO islope = 1,nslope
+        emis(ig)= emis(ig)+emiss_slope(ig,islope) &
                          *subslope_dist(ig,islope) 
-        ENDDO
-       ENDDO
-      
-
-
-!------------------------
+      ENDDO
+    ENDDO
+
+! III_a.4 Pressure (for start)
+     do i=1,ip1jmp1
+       ps(i)=ps(i)*global_ave_press_new/global_ave_press_GCM
+     enddo
+
+     do i = 1,ngrid
+       ps_phys(i)=ps_phys(i)*global_ave_press_new/global_ave_press_GCM
+     enddo
+
+! III_a.5 Tracer (for start)
+     allocate(zplev_new(ngrid,nlayer+1))
+
+     do l=1,nlayer+1
+       do ig=1,ngrid
+         zplev_new(ig,l) = ap(l)  + bp(l)*ps_phys(ig)
+       enddo
+     enddo
+
+     DO nnq=1,nqtot
+       if (noms(nnq).NE."co2") then
+         DO l=1,llm-1
+           DO ig=1,ngrid
+             q(ig,l,nnq)=q(ig,l,nnq)*(zplev_gcm(ig,l)-zplev_gcm(ig,l+1))/(zplev_new(ig,l)-zplev_new(ig,l+1))
+           ENDDO
+           q(:,llm,nnq)=q(:,llm-1,nnq)
+         ENDDO
+       else
+         DO l=1,llm-1
+           DO ig=1,ngrid
+             q(ig,l,nnq)=q(ig,l,nnq)*(zplev_gcm(ig,l)-zplev_gcm(ig,l+1))/(zplev_new(ig,l)-zplev_new(ig,l+1))  &
+                             + (   (zplev_new(ig,l)-zplev_new(ig,l+1))  -       &
+                                   (zplev_gcm(ig,l)-zplev_gcm(ig,l+1))     )  / &
+                                   (zplev_new(ig,l)-zplev_new(ig,l+1))
+           ENDDO
+           q(:,llm,nnq)=q(:,llm-1,nnq)
+         ENDDO
+       endif
+     ENDDO
+
+! Conserving the tracers's mass for GCM start files
+     DO nnq=1,nqtot
+       DO ig=1,ngrid
+         DO l=1,llm-1
+           if(q(ig,l,nnq).GT.1 .and. (noms(nnq).NE."dust_number" .or. noms(nnq).NE."ccn_number") ) then
+             extra_mass=(q(ig,l,nnq)-1)*(zplev_new(ig,l)-zplev_new(ig,l+1))
+             q(ig,l,nnq)=1.
+             q(ig,l+1,nnq)=q(ig,l+1,nnq)+extra_mass*(zplev_new(ig,l+1)-zplev_new(ig,l+2))
+           endif
+           if(q(ig,l,nnq).LT.0) then
+             q(ig,l,nnq)=1E-30
+           endif
+         ENDDO
+       enddo
+     enddo
+     
+!------------------------
+     if(evol_orbit_pem) then
+      call recomp_orb_param(year_iter)
+     endif
 
 ! III Output
-!    III_a Recomp tendencies for the start and startfi
+!    III_a Update surface value for the PCM start files
 !    III_b Write start and starfi.nc
 
@@ -1386,17 +1263,7 @@
       ztime_fin=0.
 
-         print *, "RVip1jmp1", ip1jmp1
      allocate(p(ip1jmp1,nlayer+1))
-         print *, "ngrid", ngrid
-         print *, "nlayer", nlayer
-          CALL pression (ip1jmp1,ap,bp,ps,p)
-     print *, "masse 1", masse(1,:)
-          CALL massdair(p,masse)
-     print *, "masse 2", masse(1,:)
-
-     do nnq=1,nqtot
-        call gr_fi_dyn(llm,ngridmx,iip1,jjp1,q_phys(:,:,nnq),q(:,:,nnq))
-     enddo
-
+     CALL pression (ip1jmp1,ap,bp,ps,p)
+     CALL massdair(p,masse)
 
       CALL dynredem0("restart_evol.nc", day_ini, phis)
@@ -1404,10 +1271,9 @@
       CALL dynredem1("restart_evol.nc",   &
       		time_0,vcov,ucov,teta,q,masse,ps)
-
+      print *, "restart_evol.nc has been written"
 
 ! III_b.2 WRITE restartfi.nc 
-
       
-             call physdem0("restartfi_evol.nc",longitude,latitude, &
+      call physdem0("restartfi_evol.nc",longitude,latitude, &
                         nsoilmx,ngrid,nlayer,nq,              &
                         ptimestep,pday,0.,cell_area,          &
@@ -1416,6 +1282,5 @@
                         subslope_dist)
 
-
-          call physdem1("restartfi_evol.nc",nsoilmx,ngrid,nlayer,nq,  &
+     call physdem1("restartfi_evol.nc",nsoilmx,ngrid,nlayer,nq,  &
                      ptimestep,ztime_fin,                        &
                      tsurf,tsoil,co2ice,albedo,emis,             &
@@ -1425,9 +1290,9 @@
                      emiss_slope,qsurf_slope,watercap_slope, TI_GCM_phys)
 
-
+      print *, "restartfi_evol.nc has been written"
 !------------------------
 
 ! III Output
-!    III_a Recomp tendencies for the start and startfi
+!    III_a Update surface value for the PCM start files
 !    III_b Write start and starfi.nc
 !    III_c Write start_pem
@@ -1435,19 +1300,10 @@
 !------------------------
 
-  
-
-         call pemdem1("restartfi_PEM.nc",ztime_fin,nsoilmx_PEM,ngrid,nslope , &
+         call pemdem1("restartfi_PEM.nc",year_iter,nsoilmx_PEM,ngrid,nslope , &
                       tsoil_PEM, TI_PEM, ice_depth,co2_adsorbded_phys)
 
-
- 
-
+      print *, "restartfi_PEM.nc has been written"
+      print *, "The PEM had run for ", year_iter, " years."
       print *, "LL & RV : So far so good"
 
-
-
-
-
-
 END PROGRAM pem
-
Index: /trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/pemetat0.F90	(revision 2835)
@@ -1,13 +1,14 @@
    SUBROUTINE pemetat0(startpem_file,filename,ngrid,nsoil_GCM,nsoil_PEM,nslope,timelen,timestep,TI_PEM,tsoil_PEM_yr1,tsoil_PEM,ice_table, &
-                      tsurf_ave_yr1,tsurf_ave,q_co2,q_h2o,ps_yr1_inst,ps_inst,tsurf_inst,tsoil_inst,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice, m_co2_regolith_phys,deltam_co2_regolith_phys)
+                      tsurf_ave_yr1,tsurf_ave,q_co2,q_h2o,ps_inst,tsurf_inst,tsoil_inst,tend_h2oglaciers,tend_co2glaciers,co2ice,waterice, m_co2_regolith_phys,deltam_co2_regolith_phys)
    
-   use iostart_PEM, only:  open_startphy, close_startphy, get_field 
+   use iostart_PEM, only:  open_startphy, close_startphy, get_field, get_var
    use comsoil_h_PEM, only: layer_PEM, mlayer_PEM,n_1km,fluxgeo,inertiedat_PEM
    use comsoil_h, only:  volcapa,inertiedat 
    use ini_soil_mod, only:  ini_icetable
-   use soil_evolution_mod, only: soil_pem_CN
+   use soil_evolution_mod, only: soil_pem,soil_pem_CN
    use adsorption_mod, only : regolith_co2adsorption
+   USE temps_mod_evol, ONLY: year_PEM
+
   implicit none
-
  
   character(len=*), intent(in) :: filename
@@ -23,5 +24,4 @@
   real,intent(in) :: q_co2(ngrid,timelen)                     ! MMR tracer co2 [kg/kg]
   real,intent(in) :: q_h2o(ngrid,timelen)                     ! MMR tracer h2o [kg/kg]
-  real,intent(in) :: ps_yr1_inst(ngrid,timelen)
   real,intent(in) :: ps_inst(ngrid,timelen)                        ! surface pressure [Pa]
   real,intent(in) :: tsurf_inst(ngrid,nslope,timelen) ! soil (mid-layer) temperature
@@ -34,8 +34,4 @@
 
 ! outputs
-
-
-
-
 
   real,intent(inout) :: TI_PEM(ngrid,nsoil_PEM,nslope) !soil (mid-layer) thermal inertia (SI)
@@ -59,9 +55,9 @@
    real :: tsoil_tmp_yr2(ngrid,nsoil_PEM,nslope)
    real :: tsoil_tmp(ngrid,nsoil_PEM,nslope)
-   real :: alph_tmp(nsoil_PEM-1)
-   real :: beta_tmp(nsoil_PEM-1)
-   real :: co2_ads_prev(ngrid) 
-   real :: ps_ave_yr1(ngrid)
-   real :: ps_ave_yr2(ngrid)
+   real :: alph_tmp(ngrid,nsoil_PEM-1)
+   real :: beta_tmp(ngrid,nsoil_PEM-1)
+   real :: co2_ads_prev(ngrid)
+   real :: year_PEM_read
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !!!
@@ -78,17 +74,19 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-
-! 0. Some initializations
- ps_ave_yr1(:) = sum(ps_yr1_inst(:,:),2)/timelen
- ps_ave_yr2(:) = sum(ps_inst(:,:),2)/timelen
-
 !1. Run
-
-
-
 
 if (startpem_file) then
    ! open pem initial state file:
    call open_startphy(filename)
+
+    if(soil_pem) then
+
+   call get_var("Time",year_PEM_read,found)
+   year_PEM=INT(year_PEM_read)
+   if(.not.found) then
+      write(*,*)'PEMetat0: failed loading year_PEM; take default=0'
+   else
+      write(*,*)'year_PEM of startpem=', year_PEM
+   endif
  
 !1. Thermal Inertia
@@ -103,5 +101,4 @@
 
       do ig = 1,ngrid
-
           if(TI_PEM(ig,nsoil_GCM,islope).lt.TI_breccia) then 
 !!! transition
@@ -110,26 +107,21 @@
             (((delta-layer_PEM(nsoil_GCM))/(TI_PEM(ig,nsoil_GCM,islope)**2))+ &
                       ((layer_PEM(nsoil_GCM+1)-delta)/(TI_breccia**2))))
-
-          do iloop=nsoil_GCM+2,n_1km
-            TI_PEM(ig,iloop,islope) = TI_breccia
-         enddo      
-         else ! we keep the high ti values
-           do iloop=nsoil_GCM+1,n_1km
-                  TI_PEM(ig,iloop,islope) = TI_PEM(ig,nsoil_GCM,islope)
-           enddo 
-
-         endif ! TI PEM and breccia comparison
-
-
+            do iloop=nsoil_GCM+2,n_1km
+              TI_PEM(ig,iloop,islope) = TI_breccia
+            enddo      
+          else ! we keep the high ti values
+            do iloop=nsoil_GCM+1,n_1km
+              TI_PEM(ig,iloop,islope) = TI_PEM(ig,nsoil_GCM,islope)
+            enddo 
+          endif ! TI PEM and breccia comparison
 !! transition
-             delta = 1000.
-             TI_PEM(ig,n_1km+1,islope) = sqrt((layer_PEM(n_1km+1)-layer_PEM(n_1km))/ &
-            (((delta-layer_PEM(n_1km))/(TI_PEM(ig,n_1km,islope)**2))+ &
-                      ((layer_PEM(n_1km+1)-delta)/(TI_bedrock**2))))
+          delta = 1000.
+          TI_PEM(ig,n_1km+1,islope) = sqrt((layer_PEM(n_1km+1)-layer_PEM(n_1km))/ &
+               (((delta-layer_PEM(n_1km))/(TI_PEM(ig,n_1km,islope)**2))+ &
+               ((layer_PEM(n_1km+1)-delta)/(TI_bedrock**2))))
           do iloop=n_1km+2,nsoil_PEM
             TI_PEM(ig,iloop,islope) = TI_bedrock
-         enddo   
-      enddo
-
+          enddo   
+      enddo
    else
      do iloop = nsoil_GCM+1,nsoil_PEM
@@ -141,6 +133,4 @@
 print *,'PEMETAT0: THERMAL INERTIA DONE'
 
-
-
 ! b. Special case for inertiedat, inertiedat_PEM
 call get_field("inertiedat_PEM",inertiedat_PEM,found)
@@ -148,7 +138,5 @@
  do iloop = 1,nsoil_GCM
    inertiedat_PEM(:,iloop) = inertiedat(:,iloop)
- enddo
-
-  
+ enddo 
 !!! zone de transition
 delta = 50.
@@ -159,5 +147,4 @@
                       ((layer_PEM(nsoil_GCM+1)-delta)/(TI_breccia**2))))
 
-
  do iloop = nsoil_GCM+2,n_1km 
        inertiedat_PEM(ig,iloop) = TI_breccia
@@ -179,6 +166,4 @@
 enddo
 
-
-
  do iloop = n_1km+2, nsoil_PEM
    do ig = 1,ngrid
@@ -187,5 +172,4 @@
  enddo
 endif ! not found
-
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -221,8 +205,8 @@
 
     tsoil_tmp_yr1(:,:,islope) = tsoil_startPEM(:,:,islope)
-    call soil_pem(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope),alph_tmp,beta_tmp)
-    call soil_pem(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope),alph_tmp,beta_tmp)
+    call soil_pem_routine(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope),alph_tmp,beta_tmp)
+    call soil_pem_routine(ngrid,nsoil_PEM,.false.,TI_PEM(:,:,islope),timestep,tsurf_ave_yr1(:,islope),tsoil_tmp_yr1(:,:,islope),alph_tmp,beta_tmp)
     tsoil_tmp_yr2(:,:,islope) = tsoil_tmp_yr1(:,:,islope)     
-    call soil_pem(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave(:,islope),tsoil_tmp_yr2(:,:,islope),alph_tmp,beta_tmp)
+    call soil_pem_routine(ngrid,nsoil_PEM,.true.,TI_PEM(:,:,islope),timestep,tsurf_ave(:,islope),tsoil_tmp_yr2(:,:,islope),alph_tmp,beta_tmp)
 
 
@@ -237,9 +221,7 @@
         enddo
      enddo
-
-
-
     
 ENDDO
+
 print *,'PEMETAT0: SOIL TEMP  DONE'
 
@@ -248,5 +230,4 @@
 !3. Ice Table
 
- 
    call get_field("ice_table",ice_table,found)
    if(.not.found) then
@@ -254,7 +235,5 @@
       write(*,*)'will reconstruct the values of ice table'
 
-
       call ini_icetable(timelen,ngrid,nsoil_PEM,TI_PEM, timestep,tsurf_ave(:,islope),tsoil_PEM(:,:,islope),tsurf_inst(:,islope,:),  tsoil_inst(:,:,islope,:),q_co2,q_h2o,ps_inst,ice_table(:,islope))
-
 
    else 
@@ -262,13 +241,9 @@
      call computeice_table(timelen,ngrid,nslope,nsoil_PEM,tsoil_inst,tsurf_inst,q_co2,q_h2o, ps_inst, ice_table)
 
-
    endif
 
 print *,'PEMETAT0: ICE TABLE  DONE'
 
-
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
 !4. CO2 Adsorption
@@ -299,12 +274,13 @@
 print *,'PEMETAT0: CO2 adsorption done  '
 
-
+endif ! soil_pem
 
 call close_startphy
 
-
 else !No startfi, let's build all by hand
 
-
+    year_PEM=0
+
+    if(soil_pem) then
 
 !a) Thermal inertia
@@ -326,7 +302,5 @@
                   TI_PEM(ig,iloop,islope) = TI_PEM(ig,nsoil_GCM,islope)
            enddo 
-
          endif
-
 
 !! transition
@@ -339,7 +313,5 @@
          enddo   
       enddo
-
 enddo
-
 
  do iloop = 1,nsoil_GCM
@@ -440,16 +412,12 @@
 print *,'PEMETAT0: CO2 adsorption done  '
 
-
-
-
-
-
-
-
-
+endif !soil_pem
 
 endif ! of if (startphy_file)
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    
+     if(soil_pem) then
+
     DO ig = 1,ngrid
       DO islope = 1,nslope
@@ -459,6 +427,4 @@
       ENDDO
     ENDDO
-
-
 
 !! small test
@@ -474,4 +440,6 @@
      ENDDO
 
+     endif!soil_pem
+
       write(*,*) "construction ok, no nan" 
      
Index: /trunk/LMDZ.COMMON/libf/evolution/pemredem.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/pemredem.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/pemredem.F90	(revision 2835)
@@ -8,5 +8,4 @@
                          day_ini,time,nslope,def_slope,subslope_dist)
 ! create physics restart file and write time-independent variables
-!  use comsoil_h, only: inertiedat, volcapa, mlayer
   use comsoil_h_PEM, only: mlayer_PEM,fluxgeo,inertiedat_PEM
   use iostart_PEM, only : open_restartphy, close_restartphy, & 
@@ -30,6 +29,4 @@
   real, intent(in) :: def_slope(nslope+1) !boundaries for bining of the slopes
   real, intent(in) :: subslope_dist(ngrid,nslope) !undermesh statistics
-
-
   
   ! Create physics start file
@@ -59,5 +56,5 @@
 end subroutine pemdem0
 
-subroutine pemdem1(filename,time,nsoil_PEM,ngrid,nslope, &
+subroutine pemdem1(filename,year_iter,nsoil_PEM,ngrid,nslope, &
                     tsoil_slope_PEM,inertiesoil_slope_PEM,ice_table,m_co2_regolith)
   ! write time-dependent variable to restart file
@@ -66,4 +63,6 @@
 
   use comsoil_h_PEM, only: mlayer_PEM,fluxgeo,inertiedat_PEM
+  USE temps_mod_evol, ONLY: year_PEM
+  use soil_evolution_mod, only: soil_pem
                 
   implicit none
@@ -74,5 +73,4 @@
   integer,intent(in) :: nsoil_PEM
   integer,intent(in) :: ngrid
-  real,intent(in) :: time
   real,intent(IN) :: tsoil_slope_PEM(ngrid,nsoil_PEM,nslope) !under mesh bining according to slope
   real,intent(IN) :: inertiesoil_slope_PEM(ngrid,nsoil_PEM,nslope) !under mesh bining according to slope
@@ -82,5 +80,7 @@
   integer :: islope
   CHARACTER*2 :: num  
+  integer, intent(IN) :: year_iter
 
+  real :: year_tot
  
   integer :: iq
@@ -88,5 +88,6 @@
   ! indexes of water vapour & water ice tracers (if any):
 
-  
+  year_tot=real(year_iter+year_PEM)
+  print *, "Year of simulation=", year_tot  
 
   ! Open file
@@ -95,7 +96,7 @@
   ! First variable to write must be "Time", in order to correctly
   ! set time counter in file
-  call put_var("Time","Temps de simulation",time)
-  
- 
+  call put_var("Time","Year of simulation",year_tot)
+
+    if(soil_pem) then
   
   ! Multidimensionnal variables (undermesh slope statistics)
@@ -103,19 +104,20 @@
   write(num,fmt='(i2.2)') islope
   call put_field("tsoil_PEM_slope"//num,"Soil temperature by slope type", &
-                 tsoil_slope_PEM(:,:,islope),time)
+                 tsoil_slope_PEM(:,:,islope),year_tot)
   call put_field("TI_PEM_slope"//num,"Soil Thermal Inertia by slope type", &
-                 inertiesoil_slope_PEM(:,:,islope),time)
+                 inertiesoil_slope_PEM(:,:,islope),year_tot)
 
   call put_field("mco2_reg_ads_slope"//num, "Mass of co2 adsorbded in the regolith", &
-                    m_co2_regolith(:,:,islope), time)
+                    m_co2_regolith(:,:,islope), year_tot)
 
 ENDDO
 
   call put_field("ice_table","Depth of ice table", &
-                 ice_table,time)
+                 ice_table,year_tot)
 
   call put_field("inertiedat_PEM","Thermal inertie of PEM ", &
-                 inertiedat_PEM,time)
+                 inertiedat_PEM,year_tot)
 
+   endif !soil_pem
 
   ! Close file
Index: /trunk/LMDZ.COMMON/libf/evolution/read_data_GCM.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/read_data_GCM.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/read_data_GCM.F90	(revision 2835)
@@ -9,4 +9,5 @@
                         nf90_inquire_dimension,nf90_close
       use comsoil_h, only: nsoilmx
+      USE soil_evolution_mod, ONLY: soil_pem
 
       IMPLICIT NONE
@@ -23,4 +24,5 @@
 ! Arguments:
   CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
+  INTEGER, INTENT(IN) :: timelen                   ! number of times stored in the file
 
   INTEGER :: iim_input,jjm_input,nlayer,nslope
@@ -34,15 +36,9 @@
   REAL, INTENT(OUT) ::  min_co2_ice_slope(iim_input+1,jjm_input+1,nslope) ! Minimum of co2_ice slope of the year
   REAL, INTENT(OUT) ::  min_h2o_ice_slope(iim_input+1,jjm_input+1,nslope) ! Minimum of co2_ice slope of the year
-!  REAL, ALLOCATABLE ::  vmr_co2_gcm(:,:,:)                     !!!!vmr_co2_phys_gcm(iim_input+1,jjm_input+1,timelen)
-  REAL, INTENT(OUT) ::  vmr_co2_gcm(iim_input+1,jjm_input+1,2676)                     !!!!vmr_co2_phys_gcm(iim_input+1,jjm_input+1,timelen)
-!  REAL, ALLOCATABLE ::  q_h2o_GCM(:,:,:)
-  REAL, INTENT(OUT) ::  q_h2o_GCM(iim_input+1,jjm_input+1,2676)
-  REAL, INTENT(OUT) ::  q_co2_GCM(iim_input+1,jjm_input+1,2676)
-!  REAL, ALLOCATABLE ::  q_co2_GCM(:,:,:)
+  REAL, INTENT(OUT) ::  vmr_co2_gcm(iim_input+1,jjm_input+1,timelen)      !!!!vmr_co2_phys_gcm(iim_input+1,jjm_input+1,timelen)
+  REAL, INTENT(OUT) ::  q_h2o_GCM(iim_input+1,jjm_input+1,timelen)
+  REAL, INTENT(OUT) ::  q_co2_GCM(iim_input+1,jjm_input+1,timelen)
   REAL, ALLOCATABLE ::  q1_co2_GCM(:,:,:)
-!  real, INTENT(OUT) ::  vmr_co2_phys_gcm(:,:)                  !!!!vmr_co2_gcm(ngrid,timelen)
-!  REAL, ALLOCATABLE ::  ps_GCM(:,:,:)
-  REAL,  INTENT(OUT) ::  ps_GCM(iim_input+1,jjm_input+1,2676)
-
+  REAL,  INTENT(OUT) ::  ps_GCM(iim_input+1,jjm_input+1,timelen)
 
 !SOIL
@@ -50,10 +46,10 @@
   REAL, INTENT(OUT) ::  tsoil_ave(iim_input+1,jjm_input+1,nsoilmx,nslope) ! Average soil temperature of the concatenated file
 
-  REAL ,INTENT(OUT) ::  tsurf_gcm(iim_input+1,jjm_input+1,nslope,2676) ! Surface temperature of the concatenated file
-  REAL , INTENT(OUT) ::  tsoil_gcm(iim_input+1,jjm_input+1,nsoilmx,nslope,2676) ! Soil temperature of the concatenated file
-
-  REAL ::  TI_gcm(iim_input+1,jjm_input+1,nsoilmx,nslope,2676) ! Thermal Inertia  of the concatenated file
+  REAL ,INTENT(OUT) ::  tsurf_gcm(iim_input+1,jjm_input+1,nslope,timelen) ! Surface temperature of the concatenated file
+  REAL , INTENT(OUT) ::  tsoil_gcm(iim_input+1,jjm_input+1,nsoilmx,nslope,timelen) ! Soil temperature of the concatenated file
+
+  REAL ::  TI_gcm(iim_input+1,jjm_input+1,nsoilmx,nslope,timelen) ! Thermal Inertia  of the concatenated file
   REAL, INTENT(OUT) ::  TI_ave(iim_input+1,jjm_input+1,nsoilmx,nslope) ! Average Thermal Inertia  of the concatenated file
-  REAL, INTENT(OUT) ::  co2_ice_slope(iim_input+1,jjm_input+1,nslope,2676) ! Minimum of co2_ice slope of the year
+  REAL, INTENT(OUT) ::  co2_ice_slope(iim_input+1,jjm_input+1,nslope,timelen) ! Minimum of co2_ice slope of the year
 !===============================================================================
 !   Local Variables 
@@ -65,5 +61,4 @@
 
   REAL,ALLOCATABLE :: time(:) ! times stored in start
-  INTEGER :: timelen ! number of times stored in the file
   INTEGER :: indextime ! index of selected time
 
@@ -74,5 +69,4 @@
   INTEGER :: islope
   CHARACTER*2 :: num
-
 
 !-----------------------------------------------------------------------
@@ -84,70 +78,43 @@
       B=1/m_noco2
 
+      allocate(co2_ice_s(iim+1,jjm+1,timelen))
+      allocate(q1_co2_GCM(iim+1,jjm+1,timelen))
+      allocate(h2o_ice_s_slope(iim+1,jjm+1,nslope,timelen))
+      allocate(h2o_ice_s(iim+1,jjm+1,timelen))
+
+  print *, "Opening ", fichnom, "..."
+
 !  Open initial state NetCDF file
   var=fichnom
   CALL err(NF90_OPEN(var,NF90_NOWRITE,fID),"open",var)
 
-      ierr = nf90_inq_varid (fID, "temps", vID)
-      IF (ierr .NE. nf90_noerr) THEN
-        write(*,*)"pemetat0: Le champ <temps> est absent"
-        write(*,*)"pemetat0: J essaie <Time>"
-        ierr = nf90_inq_varid (fID, "Time", vID)
-        IF (ierr .NE. nf90_noerr) THEN
-           write(*,*)"pemetat0: Le champ <Time> est absent"
-           write(*,*)trim(nf90_strerror(ierr))
-     print *, "ICIIII0"
-           CALL ABORT_gcm("pemetat0", "", 1)
-        ENDIF
-        ! Get the length of the "Time" dimension
-     print *, "ICIIIITIME"
-        ierr = nf90_inq_dimid(fID,"Time",vID)
-        ierr = nf90_inquire_dimension(fID,vID,len=timelen)
-      ELSE   
-        ! Get the length of the "temps" dimension
-     print *, "ICIIIITEMPS"
-        ierr = nf90_inq_dimid(fID,"temps",vID)
-        ierr = nf90_inquire_dimension(fID,vID,len=timelen)
-      ENDIF
-
-     print *, "ICIIII"
-
-      allocate(co2_ice_s(iim+1,jjm+1,timelen))
-
-     print *, "ICIIIIAAAA"
-
-!      allocate(q_co2_GCM(iim+1,jjm+1,timelen))
-
-     print *, "ICIIIIBBBB"
-
-!      allocate(q_h2o_GCM(iim+1,jjm+1,timelen))
-
-     print *, "ICIIIICCCC"
-
-      allocate(q1_co2_GCM(iim+1,jjm+1,timelen))
-
-     print *, "ICIIII2"
-
-
-
-      allocate(h2o_ice_s_slope(iim+1,jjm+1,nslope,timelen))
-      allocate(h2o_ice_s(iim+1,jjm+1,timelen))
-          print *, "ICIIII3"
+     print *, "Downloading data for h2oice ..."
 
 ! Get h2o_ice_s of the concatenated file
   CALL get_var3("h2o_ice_s"   ,h2o_ice_s)
 
-  print *, "A"
+     print *, "Downloading data for h2oice done"
+     print *, "Downloading data for co2ice ..."
 
   CALL get_var3("co2ice"   ,co2_ice_s)
+
+     print *, "Downloading data for co2ice done"
+     print *, "Downloading data for vmr co2..."
+
   CALL get_var3("co2_cropped"   ,q_co2_GCM)
+
+     print *, "Downloading data for vmr co2 done"
+     print *, "Downloading data for vmr h20..."
+
   CALL get_var3("h2o_cropped"   ,q_h2o_GCM)
 
-  print *, "B"
+     print *, "Downloading data for vmr h2o done"
+     print *, "Downloading data for surface pressure ..."
 
   CALL get_var3("ps"   ,ps_GCM)
 
-  print *, "C"
-
-  print *, "nslope", nslope
+     print *, "Downloading data for surface pressure done"
+     print *, "nslope=", nslope
+     print *, "Downloading data for co2ice_slope ..."
 
 DO islope=1,nslope
@@ -156,5 +123,6 @@
 ENDDO
 
-  print *, "co2ice_slope"
+     print *, "Downloading data for co2ice_slope done"
+     print *, "Downloading data for h2o_ice_s_slope ..."
 
 DO islope=1,nslope
@@ -163,5 +131,6 @@
 ENDDO
 
-  print *, "h2o_ice_s_slope"
+     print *, "Downloading data for h2o_ice_s_slope done"
+     print *, "Downloading data for tsurf_slope ..."
 
 DO islope=1,nslope
@@ -170,5 +139,9 @@
 ENDDO
 
-  print *, "tsurf_slope"
+     print *, "Downloading data for tsurf_slope done"
+
+     if(soil_pem) then
+
+     print *, "Downloading data for tsoil_slope ..."
 
 DO islope=1,nslope
@@ -177,5 +150,6 @@
 ENDDO
 
-  print *, "tsoil_slope"
+     print *, "Downloading data for tsoil_slope done"
+     print *, "Downloading data for inertiesoil_slope ..."
 
 DO islope=1,nslope
@@ -184,27 +158,30 @@
 ENDDO
 
-  print *, "inertiesoil_slope"
-
-
-
-
+     print *, "Downloading data for inertiesoil_slope done"
+
+  endif
 
 ! Compute the minimum over the year for each point
+  print *, "Computing the min of h2o_ice"
   min_h2o_ice_s(:,:)=minval(h2o_ice_s,3)
+  print *, "Computing the min of co2_ice"
   min_co2_ice_s(:,:)=minval(co2_ice_s,3)
 
+  print *, "Computing the min of h2o_ice_slope"
+  min_h2o_ice_slope(:,:,:)=minval(h2o_ice_s_slope,4)
+  print *, "Computing the min of co2_ice_slope"
   min_co2_ice_slope(:,:,:)=minval(co2_ice_slope,4)
-  min_h2o_ice_slope(:,:,:)=minval(h2o_ice_s_slope,4)
 
 !Compute averages
 
-!  DO i=1,timelen
+    print *, "Computing average of tsurf"
     tsurf_ave(:,:,:)=SUM(tsurf_gcm(:,:,:,:),4)/timelen
+
+  if(soil_pem) then
+    print *, "Computing average of tsoil"
     tsoil_ave(:,:,:,:)=SUM(tsoil_gcm(:,:,:,:,:),5)/timelen
+    print *, "Computing average of TI"
     TI_ave(:,:,:,:)=SUM(TI_gcm(:,:,:,:,:),5)/timelen
-!  ENDDO
-
-
-
+  endif
 
 ! By definition, a density is positive, we get rid of the negative values
@@ -229,7 +206,4 @@
     DO j = 1, jjm+1
       DO t = 1, timelen
-!         q1_co2_GCM(i,j,t)=q_co2_GCM(i,j,t)
-!         ps_GCM(i,j,t)=ps(i)
-!c             Mean air molecular mass = 1/(q(ico2)/m_co2 + (1-q(ico2))/m_noco2)
          if (q_co2_GCM(i,j,t).LT.0) then
               q_co2_GCM(i,j,t)=1E-10
@@ -248,9 +222,4 @@
   ENDDO
 
-
-
-
-
-
   CONTAINS
 
Index: /trunk/LMDZ.COMMON/libf/evolution/recomp_orb_param_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/recomp_orb_param_mod.F90	(revision 2835)
+++ /trunk/LMDZ.COMMON/libf/evolution/recomp_orb_param_mod.F90	(revision 2835)
@@ -0,0 +1,72 @@
+      MODULE recomp_orb_param_mod
+
+      IMPLICIT NONE
+
+      CONTAINS
+
+      SUBROUTINE recomp_orb_param(final_iter)
+
+      USE temps_mod_evol, ONLY: year_bp_ini, year_PEM
+      USE planete_h, ONLY: e_elips, obliquit, timeperi
+      USE comcstfi_h, only: pi
+      USE lask_param_mod, only: yearlask,oblask,exlask,lsplask, &
+   				end_lask_param_mod,last_ilask
+
+      IMPLICIT NONE
+
+!--------------------------------------------------------
+! Input Variables
+!--------------------------------------------------------
+
+      integer,intent(in) :: final_iter ! Number of year iteration of the PEM 
+
+!--------------------------------------------------------
+! Output Variables
+!--------------------------------------------------------
+
+!--------------------------------------------------------
+! Local variables 
+!--------------------------------------------------------
+
+      real :: Year	                ! Year of the simulation
+      real :: timeperi_ls	        ! time of peri in ls
+      integer ilask			! Loop variable
+
+
+      ! **********************************************************************
+      ! 0. Initializations
+      ! **********************************************************************
+
+
+          Year=year_bp_ini+year_PEM+final_iter
+
+          timeperi_ls=timeperi*360/2/pi
+
+!          Year=-953200
+          print *, "recomp_orb_param, Old year=", year_bp_ini+year_PEM
+          print *, "recomp_orb_param, New year=", Year
+          print *, "recomp_orb_param, Old obl=", obliquit
+          print *, "recomp_orb_param, Old ex=", e_elips
+          print *, "recomp_orb_param, Old lsp=", timeperi_ls
+          print *, "recomp_orb_param, Old timeperi=", timeperi
+
+        do ilask=last_ilask,1,-1
+           if(yearlask(ilask) .GT.Year) then
+              obliquit=oblask(ilask+1)+(oblask(ilask)-oblask(ilask+1))*(Year-yearlask(ilask+1))/(yearlask(ilask)-yearlask(ilask+1))
+              e_elips=exlask(ilask+1)+(exlask(ilask)-exlask(ilask+1))*(Year-yearlask(ilask+1))/(yearlask(ilask)-yearlask(ilask+1))
+              timeperi_ls=lsplask(ilask+1)+(lsplask(ilask)-lsplask(ilask+1))*(Year-yearlask(ilask+1))/(yearlask(ilask)-yearlask(ilask+1))
+              exit
+           endif
+        enddo
+        timeperi=timeperi_ls*2*pi/360
+
+       print *, "recomp_orb_param, Final year of the PEM run:", Year
+       print *, "recomp_orb_param, New obl=", obliquit
+       print *, "recomp_orb_param, New ex=", e_elips
+       print *, "recomp_orb_param, New timeperi=", timeperi
+
+      END SUBROUTINE recomp_orb_param
+
+!********************************************************************************   
+      
+      END MODULE recomp_orb_param_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_slope.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_slope.F90	(revision 2834)
+++ /trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_slope.F90	(revision 2835)
@@ -20,14 +20,10 @@
   REAL, INTENT(in) ::  vmr_co2_pem(ngrid,timelen)                ! physical point field : Volume mixing ratio of co2 in the first layer
   REAL, intent(in) :: ps_GCM_2(ngrid,timelen)                 ! physical point field : Surface pressure in the GCM
-!  REAL, INTENT(in) ::  q_co2_GCM(ngrid)                ! physical point field : Density of co2 in the first layer
-!  REAL, intent(in) :: ps_GCM(ngrid)                 ! physical point field : Density of co2 in the first layer
   REAL, intent(in) :: global_ave_press_GCM
   REAL, intent(in) :: global_ave_press_new
   REAL, intent(in) ::  tendencies_co2_ice_phys_ini(ngrid,nslope) ! physical point field : Evolution of perenial ice over one year
 
-
 !   OUTPUT
   REAL, intent(inout) ::  tendencies_co2_ice_phys(ngrid,nslope) ! physical point field : Evolution of perenial ice over one year
-
 
 !   local:
@@ -45,29 +41,14 @@
   coef=669*24*3600*eps*sigma/L
 
-  print *, "coef", coef
-  print *, "global_ave_press_GCM", global_ave_press_GCM
-  print *, "global_ave_press_new", global_ave_press_new
-
 ! Evolution of the water ice for each physical point
   do i=1,ngrid
     do islope=1,nslope
-       ave=0.
-    do t=1,timelen
-
-!       write(*,*)'i,t=',i,t,islope, alpha,beta,ave,vmr_co2_gcm(i,t),vmr_co2_pem(i,t),ps_GCM_2(i,t),global_ave_press_GCM,global_ave_press_new
-       ave=ave+(beta/(alpha-log(vmr_co2_gcm(i,t)*ps_GCM_2(i,t)/100)))**4  &
+      ave=0.
+      do t=1,timelen
+        ave=ave+(beta/(alpha-log(vmr_co2_gcm(i,t)*ps_GCM_2(i,t)/100)))**4  &
               -(beta/(alpha-log(vmr_co2_pem(i,t)*ps_GCM_2(i,t)*global_ave_press_GCM/global_ave_press_new/100)))**4
+      enddo
+      tendencies_co2_ice_phys(i,islope)=tendencies_co2_ice_phys_ini(i,islope)-coef*ave/timelen
     enddo
-!    print *, "i", i
-!    print *, "tendencies_co2_ice_phys_ini bef", tendencies_co2_ice_phys_ini(i,islope)
-!    tendencies_co2_ice_phys(i,islope)=tendencies_co2_ice_phys_ini(i,islope)+coef*ave/timelen
-    tendencies_co2_ice_phys(i,islope)=tendencies_co2_ice_phys_ini(i,islope)-coef*ave/timelen
-
-!    print *, "tendencies after", tendencies_co2_ice_phys(i,islope)
-!    print *, "ave", ave
-!    print *, "timelen", timelen
-!    print *, "vmr_co2_pem(i,t)*ps_GCM_2(i,t)", vmr_co2_pem(i,t)*ps_GCM_2(i,t)
-!    print *, "-------------------"
-  enddo
   enddo
 
